#include "Sched.h"

void Scheduler::removeEvents(ITimedElement *target)
{
	// Ponovo napuniti listu dogadjaja 
	// sa svim vec postojecim dogadjajima 
	// osim sa onima koji se odnose na target
	if (target == 0) return;
	
	// Pamti se pocetak postojece liste
	// i pocinje sa uporedjivanjem od pocetka
	Event* frs = first;           
	Event *tmp = first;           
	
	// Pocinje se nova lista
	first = 0;                    
	while (tmp!=0) 
	{
		// Ako dogadjaj ne treba izbaciti
		if (tmp->getTarget() != target)  
		{
			// Dodaje se u novu listu
			put(tmp);                    
		}
		// Prelazak na sledeci
		tmp = tmp->getNext();            
	}
	// Nakon pravljenja nove liste (tj. izbacivanja nezeljenih)
	// mora se obrisati stara lista
	tmp = frs;
	
	while (frs!=0) 
	{
		tmp = frs->getNext();
		delete frs;
		frs = tmp;
	}
}
