#include "Sanker.h"
#include "Posetilac.h"

void Sanker::accept (Visitor* vis)
{
	if (vis) vis->visitSanker(this);
}

void Sanker::notify(int ID)
{
	// Kada Sanker dobije notify od Scheduler-a,
	// treba da nadje prvog sledeceg aktivnog
	// posetioca i da mu "sipa" pivo preko acceptFlow()
	int i = trenutniBrPos;
	int brojac=0;
	while ((pos[i]==0) && (brojac<N))
	{
		i++; i=i%N; brojac++;
	}
	
	// Ako uopste ima Posetioce
	if (brojac<N) 
	{
		pos[i] ->acceptFlow();
		trenutniBrPos = i++;
		trenutniBrPos = trenutniBrPos % N;
	}
	// i nakon toga da se opet prijavi Scheduler-u
	// preko raiseEvent() za sledece sipanje piva
	raiseEvent ();
}

bool Sanker::addPosetilac(Posetilac* p)
{
	int i=0;
	while ((pos[i]==0) && (i<N)) 
		i++;
	
	if (i<N) 
	{
		pos[i] = p;
		return true;
	}
	else 
		return false;
}
