#include "Posetilac.h"

#include "Visitor.h"
#include "UniRndGen.h"

void Posetilac::accept (Visitor* vis)
{
	if (vis) vis->visitPosetilac (this);
}

void Posetilac::acceptFlow()
{
	// Kada dobije pivo, broj piva se uvecava za 1
	// i prijavljuje se Event Sheduler-u
	// za vreme koje vrati Uniform generator
	// za odlazak u Sanitarni Cvor
	brojPiva++;
	raiseEvent ();
}

void Posetilac::notify (int ID)
{
	// Kada Scheduler obavesti Posetioca, on odlazi do Sanitarnog cvora
	// gde se izvrsava izbacivanje jednog piva
	if (target)
	{
		send();
		brojPiva--;
	}
}
