#ifndef Visitor_h
#define Visitor_h 1

class Model;

class UniformGenerator;
class ExpGenerator;

class FlowSource;
class FlowSink;
class Pipe;
class QueuedServer;
class Switch1to3;
class CrossSemaphore;

class Sanker;
class Posetilac;
class SanitarniCvor;

class Visitor 
{
public:
	virtual void visitModel (Model* e);
	virtual void visitUniformGenerator (UniformGenerator* e);
	virtual void visitExpGenerator (ExpGenerator* e);
	virtual void visitFlowSource (FlowSource* e);
	virtual void visitFlowSink (FlowSink* e);
	virtual void visitPipe (Pipe* e);
	virtual void visitQueuedServer (QueuedServer* e);
	virtual void visitSwitch1to3 (Switch1to3* e);
	virtual void visitCrossSemaphore (CrossSemaphore* e);
	virtual void visitSanker(Sanker*);
	virtual void visitPosetilac(Posetilac*);
	virtual void visitSanitarniCvor(SanitarniCvor*);
};

inline void Visitor::visitUniformGenerator (UniformGenerator* e)
{
}

inline void Visitor::visitExpGenerator (ExpGenerator* e)
{
}

inline void Visitor::visitFlowSource (FlowSource* e)
{
}

inline void Visitor::visitFlowSink (FlowSink* e)
{
}

inline void Visitor::visitPipe (Pipe* e)
{
}

inline void Visitor::visitQueuedServer (QueuedServer* e)
{
}

inline void Visitor::visitSwitch1to3 (Switch1to3* e)
{
}

inline void Visitor::visitCrossSemaphore (CrossSemaphore* e)
{
}

inline void Visitor::visitSanker(Sanker*)
{
}

inline void Visitor::visitPosetilac(Posetilac*)
{
}

inline void Visitor::visitSanitarniCvor(SanitarniCvor*)
{
}

#endif
